;esta macro ajuda a desenhar octaedro pela indicao de dois vertices
;da mesma aresta
;;desenha caixas com a forma do octoedros
;quando se tratar de uma caixa  necessario indicar uma espessura
;;Est limitado ao uso do UCS principal
;Lus Romo, agosto 2016

(defun ares_octa ()
	(setq dia (sqrt (* 2 (expt (/ (distance pt1 pt2) 2) 2))))
    (setq pt0 (polar pt1 (+ (angle pt1 pt2) (/ pi 4)) dia))
	(setq pt3 (list (car pt0) (cadr pt0) (+ (caddr pt0) dia)))
	(command "3dface" pt1 pt2 pt3 "" "")
		(command "ucs" "3p" pt1 pt2 pt3)
		(command "extrude" (entlast) "" "t" 35 (* -1 espessura))
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))
	(setq nu (+ 1 nu))
			(command "ucs" "w")
	)

(defun sim_cir ()
	(command "copy" (entlast) "" pt3 pt3)
	(command "rotate" (entlast) "" pt3 90)
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))
	(setq nu (+ 1 nu))
	)
	
(defun espelho ()
	(command "ucs" "x" 90)
	(command "ucs" (trans pt0 0 1) "")
	(command "mirror" (entlast) "" (list 0 0) (list 1 0) "n")
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))
	(setq nu (+ 1 nu))
	(command "ucs" "w")	
	)
;;;funo principal do comando que coordena a sua execuo
(defun c:octa ()
	(setq pontos2d (getvar "osmode"))
	(setq pontos3d (getvar "3dosmode"))
	(setq lista nil)
	(setq nu 0)
	(setvar "3dosmode" 8)
	(setq pt1 (getpoint "indique o primeiro ponto da aresta:  "))
	(setq pt2 (getpoint "indique o segundo ponto da aresta:   "))
		(if (equal
		(setq espessura (getreal "Qual  a espessura que quer usar?  ")) nil)
		(setq espessura (* 1.5 (distance pt1 pt2)))
			)
	(setvar "3dosmode" 0)	
	(ares_octa)
	(repeat 3	(sim_cir))
	(espelho)
	(repeat 3	(sim_cir))
	(command "union" )
    (foreach p lista (command p)) 
    (command "")	
	(setvar "osmode" pontos2d)
	(setvar "3dosmode" pontos3d)
	(setq lista nil nu nil)	
)
