;esta macro ajuda a desenhar caixas e slidos em forma de tetraedro pela indicao de dois vertices
;da mesma aresta
;quando se tratar de uma caixa  necessario indicar uma espessura
;;Est limitado ao uso do UCS principal
;Lus Romo, agosto 2016

(defun cen_triEq ()
	(setq pt3a (polar pt1 (angle pt1 pt2) (/ (distance pt1 pt2) 2)))
	(setq pt3  (polar pt3a (+ (angle pt1 pt2)(/ pi 2)) (* (/ (sqrt 3) 3.0) (/ (distance pt1 pt2) 2))))
	(setq pt4 (list (car pt3)
				(cadr pt3)
				(+ (caddr pt1) 
						(sqrt (- (expt (distance pt1 pt2) 2)(expt (distance pt1 pt3) 2)))
			))
			)
	(command "3dface" pt1 pt2 pt4 "" "")
	(command "ucs" "3p" pt1 pt2 pt4)
	(command "extrude" (entlast) "" "t" 35 (* -1 espessura))
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))	
	(setq nu (+ 1 nu))
	(command "ucs" "w")
	(repeat 2 (sem_cir))
	(command "3dface" pt1 pt2 (polar pt2 (+ (angle pt1 pt2) (* (/ pi 3) 2)) (distance pt1 pt2))  "" "")
		(command "ucs" "3p" pt1 pt2 (polar pt2 (+ (angle pt1 pt2) (* (/ pi 3) 2)) (distance pt1 pt2)))
		(command "extrude" (entlast) "" "t" 35 espessura)
		(command "ucs" "w")		
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))
	(setq nu (+ 1 nu))	
)
;reproduz e roda a primeira entidade at perfazer as 3 faces
(defun sem_cir ()
	(command "copy" (entlast) "" pt4 pt4)
	(command "rotate" (entlast) "" pt4 120)
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))
	(setq nu (+ 1 nu))
)
;;;funo principal do comando que coordena a sua execuo
(defun c:tetra ()
	(setq pontos2d (getvar "osmode"))
	(setq pontos3d (getvar "3dosmode"))
	(setvar "osmode" 0)
	(setvar "3dosmode" 0)
	(setq nu 0)
		(setvar "3dosmode" 8)
	(setq pt1 (getpoint "indique o primeiro ponto da aresta: "))
	(setq pt2 (getpoint "indique o segundo  ponto da aresta: "))
	(if (equal
	(setq espessura (getreal "Qual  a espessura que quer usar?  ")) nil)
	(setq espessura (* 1.5 (distance pt1 pt2)))
	)
	(setvar "3dosmode" 0)
	(cen_triEq)
	(command "union" )
		(foreach p lista (command p)) 
			(command "")
	(setvar "osmode" pontos2d)
	(setvar "3dosmode" pontos3d)
	(setq lista nil nu nil)	
	(command "ucs" "w")
)
		   