;esta macro ajuda a desenhar caixas e slidos em forma do dodecaedro pela indicao de dois vertices
;da mesma aresta
;quando se tratar de uma caixa  necessrio indicar uma espessura
;;Est limitado ao uso do UCS principal
;Lus Romo, agosto 2016
;;funo que indentifica todas as coordenadas dos pontos a utilizar neste comando
(defun pontos ()
	(setq pt0 (polar pt1 (angle pt1 pt2)(/ (distance pt1 pt2) 2)))
	(setq pt3 (polar pt0 (- (angle pt1 pt2) (/ pi 4)) (/ (sqrt (* 2 (expt (aurea (distance pt1 pt2)) 2))) 2)))
	(setq pt4 (polar pt0 (+ (angle pt1 pt2) (/ pi 4)) (/ (sqrt (* 2 (expt (aurea (distance pt1 pt2)) 2))) 2)))
	(setq pt5 (polar pt0 (+ (angle pt1 pt2) (* 3 (/ pi 4))) (/ (sqrt (* 2 (expt (aurea (distance pt1 pt2)) 2))) 2)))
	(setq pt6 (polar pt0 (- (angle pt1 pt2) (* 3 (/ pi 4))) (/ (sqrt (* 2 (expt (aurea (distance pt1 pt2)) 2))) 2)))
	(setq dista (sqrt (- (expt (distance pt1 pt2) 2)(expt (distance pt1 pt6) 2))))
	(setq pt3 (list (car pt3) (cadr pt3) (- (caddr pt3) dista)))
	(setq pt4 (list (car pt4) (cadr pt4) (- (caddr pt4) dista)))
	(setq pt5 (list (car pt5) (cadr pt5) (- (caddr pt5) dista)))
	(setq pt6 (list (car pt6) (cadr pt6) (- (caddr pt6) dista)))
	(setq pt00 (list (car pt0) (cadr pt0) (- (caddr pt0) dista (/ (aurea (distance pt1 pt2)) 2))))
	)
;;;funo que desenha o conjunto primordial de superficies
(defun faces ()
	(command "3dface" pt6 pt1 pt2 pt3 "" )
		(command "extrude" (entlast) "" espessura )
	(nomear)
	(command "3dface" pt2 pt3 pt4 "" "" )
		(command "extrude" (entlast) "" espessura )
	(nomear)
	(command "3dface" pt4 pt2 pt1 pt5 "" )
		(command "extrude" (entlast) "" espessura )
	(nomear)
	(command "3dface" pt1 pt5 pt6 "" "" )
		(command "extrude" (entlast) "" espessura )
	(nomear)
	)
;;funo que calcula a porproo aurea de qualquer face pentagonal
(defun aurea (valor)
		(* (/ (+ 1 (sqrt 5)) 2) valor)
		)
;;funo que representa as faces restantes seguindo vrias transformaes geomtricas
(defun construcao ()
	(command "ucs" "3p" pt6 pt3 pt5)
	(command "copy" (entlast) "" (trans pt00 0 1)(trans pt00 0 1))
	(command "rotate" (entlast) "" (trans pt00 0 1) 90)
	(nomear)
	(command "ucs" "x" 90)
	(command "rotate" (entlast) "" (trans pt00 0 1) 90)
	(command "copy" (entlast) "" (trans pt00 0 1)(trans pt00 0 1))
	(nomear)
	(command "ucs" "y" 90)
	(command "rotate" (entlast) "" (trans pt00 0 1) 90)
	(command "ucs" "p")
	(command "rotate" (entlast) "" (trans pt00 0 1) 90)
	(command "ucs" "3p" (trans pt6 0 1) (trans pt3 0 1) (trans pt5 0 1))
	(command "copy" (entlast) "" (trans pt00 0 1)(trans pt00 0 1))
	(nomear)
	(command "rotate" (entlast) "" (trans pt00 0 1) 90)
	(command "ucs" "x" 90)
	(command "rotate" (entlast) "" (trans pt00 0 1) 90)
	(command "copy" (entlast) "" (trans pt00 0 1)(trans pt00 0 1))
	(nomear)
	(command "ucs" "y" 90)
	(command "rotate" (entlast) "" (trans pt00 0 1) 90)
	(command "ucs" "3p" (trans pt6 0 1) (trans pt3 0 1) (trans pt5 0 1))
	(command "rotate" (entlast) "" (trans pt00 0 1) 90)
	(command "copy" (entlast) "" (trans pt00 0 1)(trans pt00 0 1))
	(nomear)
	(command "rotate" (entlast) "" (trans pt00 0 1) 180)
	)	
	
;;;funo que identifica as faces e as coloca dentro de um lista
(defun nomear ()
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))
	(setq nu (+ 1 nu))
	)
;;;funo principal do comando que coordena a sua execuo
(defun c:dode ()
	(setq pontos2d (getvar "osmode"))
	(setq pontos3d (getvar "3dosmode"))
	(setq lista nil)
	(setq nu 0)
	(setq pt1 (getpoint "indique o primeiro ponto da aresta:  "))
	(setq pt2 (getpoint "indique o segundo ponto da aresta:   "))
	(if (equal
	(setq espessura (getreal "Qual  a espessura que quer usar?  ")) nil)
	(setq espessura (* -1.5 (distance pt1 pt2)))
	)
	(setvar "3dosmode" 0)
	(setvar "osmode" 0)
	(pontos)
	(faces)
		(command "union" )
		(foreach p lista (command p)) 
		(command "")
		(setq lista nil)
		(nomear)
	(construcao)
		(command "union" )
		(foreach p lista (command p)) 
		(command "")
	(setvar "osmode" pontos2d)
	(setvar "3dosmode" pontos3d)
	(setq lista nil nu nil espessura nil)
	(command "ucs" "w")
	)
