;esta macro ajuda a desenhar cubos pela indicao de dois vertices
;da mesma aresta
;;desenha caixas com a forma do cubos
;;o utilizador deve fornecer a espessura
;;Est limitado ao uso do UCS principal
;Lus Romo, agosto 2016

(defun cubo_faces ()
	(setq pt3 (list (car pt2) (cadr pt2) (+ (caddr pt2) (distance pt1 pt2))))
	(setq pt4 (list (car pt1) (cadr pt1) (+ (caddr pt1) (distance pt1 pt2))))
	(setq pt0a (polar pt1 (+ (angle pt1 pt2) (/ pi 4)) (/ (* (sqrt 2)(distance pt1 pt2)) 2)))
	(setq pt0 (list (car pt0a)
					(cadr pt0a)
					(+ (caddr pt0a) (/ (distance pt1 pt2) 2))))
	(command "3dface" pt1 pt2 pt3 pt4 "")
	(command "ucs" "3p" pt1 pt2 pt4)
	(command "extrude" (entlast) "" "t" 40 (* -1 espessura))
	(nomear)
	(command "ucs" "w")
	(repeat 3
		(command "copy" (entlast) "" pt0 pt0)
		(command "rotate" (entlast) "" pt0 90)
		(nomear))
		(command "ucs" "3p" pt1 pt2 pt4)
		(command "mirror" (entlast) "" (trans pt1 0 1) (trans pt3 0 1) "n")
		(nomear)
		(command "copy" (entlast) "" pt0 pt0)			
		(command "rotate" (entlast) "" (trans pt0 0 1) 180)
		(nomear)		
	)
;;;guarda na lista lista as faces que vo sendo criadas
(defun nomear ()
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))	
		(setq nu (+ 1 nu))
	)
;;;funo principal do comando que coordena a sua execuo
(defun c:cubo ()
	(setq pontos2d (getvar "osmode"))
	(setq pontos3d (getvar "3dosmode"))
	(setvar "osmode" 0)
	(setvar "3dosmode" 0)
	(setq nu 0)
		(setvar "3dosmode" 8)
	(setq pt1 (getpoint "indique o primeiro ponto da aresta: "))
	(setq pt2 (getpoint "indique o segundo  ponto da aresta: "))
	(if (equal
		(setq espessura (getreal "Qual  a espessura que quer usar?  ")) nil)
		(setq espessura (* 1.5 (distance pt1 pt2)))
		)
	(setvar "3dosmode" 0)
	(cubo_faces)
	(command "union" )
		(foreach p lista (command p)) 
			(command "")
	(setvar "osmode" pontos2d)
	(setvar "3dosmode" pontos3d)
	(setq lista nil nu nil)	
	(command "ucs" "w")
	)