;esta macro ajuda a desenhar icosaedros pela indicao de dois vertices
;da mesma aresta
;;desenha caixas com a forma do icosaedros
;quando se tratar de uma caixa  necessario indicar uma espessura
;;Est limitado ao uso do UCS principal
;Lus Romo, agosto 2016

(defun aresta ()
	(setq pt2a (polar pt1 (+ (angle pt1 pt2) (dtr 54)) (/ (/ (distance pt1 pt2) 2) (cos (dtr 54)))))
	(setq pt3 (list (car pt2a)
				    (cadr pt2a)
				    (+ (caddr pt2a)(sqrt (- (expt (distance pt1 pt2) 2) (expt (distance pt1 pt2a) 2))))))
	(setq pt4 (polar pt2 (- (angle pt2 pt1) (dtr 108))(distance pt2 pt1)))
	(setq pt5a (polar pt1 (+  (angle pt1 pt2) (dtr 108))(distance pt2 pt1)))
	(setq pt5 (polar pt5a (-  (angle pt1 pt5a) (dtr 72))(distance pt2 pt1)))
	(command "3dface" pt1 pt2 pt3 "" "")
		(command "ucs" "3p" pt1 pt2 pt3)
	(command "extrude" (entlast) "" "t" 20 (* -1 espessura))
		(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))	
		(setq nu (+ 1 nu))
			(command "ucs" "w")
	(repeat 4 (copiar_rodar))	
	(command "ucs" "3p" pt1 pt3 pt4)
	(setq pt_esp (polar (trans pt3 0 1) (angle (trans pt3 0 1) (trans pt2 0 1)) (distance (trans pt1 0 1) (trans pt2a 0 1))))
	(setq pt0 (inters (trans pt3 0 1) (trans pt2a 0 1) (trans pt2 0 1) pt_esp onseg))
	(setq pt0f (trans pt0 1 0))
	(setq pt7 (polar (trans pt4 0 1) (- (angle (trans pt4 0 1)(trans pt3 0 1)) (dtr 108)) (distance (trans pt1 0 1) (trans pt2 0 1))))
	(setq pt7w (trans pt7 1 0))
	(command "ucs" "w")
	(command "3dface" pt2 pt4 pt7w "" "")
		(command "ucs" "3p" pt2 pt4 pt7w)
	(command "extrude" (entlast) "" "t" 20 espessura)
;		(command "extrude" (entlast) "" "t" 45 (* -1 espessura))
	(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))	
	(setq nu (+ 1 nu))
		(command "ucs" "w")
	(repeat 4 (copiar_rodar))	
	(repeat 10 (espelho))	
	)

(defun DtR (d) (* pi (/ d 180.0)))

(defun copiar_rodar ()
		(command "copy"   (entlast) "" pt3 pt3)
		(command "rotate" (entlast) "" pt3 72)
			(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))
			(setq nu (+ 1 nu))
			)
			
(defun espelho ()
	(command "ucs" "x" 90)
	(command "mirror" (nth (setq n_lista (+ 1 n_lista)) lista) ""
		(trans pt0f 0 1) (list (- (car (trans pt0f 0 1)) 1)(cadr (trans pt0f 0 1))) "n")
	(command "ucs" "w")
	(command "rotate" (entlast) "" pt0f 36)	
			(setq lista (append lista (list (set (read (strcat "entidade" (rtos nu))) (entlast)))))
			(setq nu (+ 1 nu))		
)
;;;funo principal do comando que coordena a sua execuo
(defun c:ico ()
	(setq pontos2d (getvar "osmode"))
	(setq pontos3d (getvar "3dosmode"))
	(setvar "osmode" 0)
	(setvar "3dosmode" 0)
	(setq nu 0)
	(setq pt1 (getpoint "Indique o primeiro ponto da aresta: "))
	(setq pt2 (getpoint "Indique o segundo  ponto da aresta: "))
	(if (equal
	(setq espessura (getreal "Qual  a espessura que quer usar?  ")) nil)
	(setq espessura (* 1.5 (distance pt1 pt2)))
	)
	(setvar "3dosmode" 0)
	(setq lista nil)
	(setq nu 0)
	(setq n_lista -1)
		(command "ucs" "w")
	(aresta)
		(setq n_lista -1)
	(command "union" )
		(foreach p lista (command p)) 
			(command "")
	(setvar "osmode" pontos2d)
	(setvar "3dosmode" pontos3d)
	(setq lista nil nu nil)	
	(command "ucs" "w")
)
